/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.geodata.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="GEODATA_PLZ.UK",
     query="SELECT o FROM GeodataPlz o WHERE "

                         + "o"
                +".plz"
              +" = ?1"

     ,
   hints = {
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="GEODATA_PLZ.All",
     query="SELECT obj FROM GeodataPlz obj",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
         ,   @javax.persistence.NamedQuery(
     name="GEODATA_PLZ.Plz",
     query="SELECT obj FROM GeodataPlz obj WHERE UPPER(obj.plz) = UPPER(?1)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "GEODATA_PLZ")
// @javax.persistence.IdClass(GeodataPlzPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    
public
 class GeodataPlz
extends AbstractGeodataPlz
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public GeodataPlz() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public GeodataPlz(GeodataPlz original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "geodata_plz_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "GeodataPlz")
    @javax.persistence.TableGenerator(name = "GeodataPlz", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "GeodataPlz", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient GeodataPlzPK pkCache;

  @Override
  public GeodataPlzPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new GeodataPlzPK(getId());
    }

    return pkCache;
  }

  public static <E extends GeodataPlz> java.util.Map<GeodataPlzPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<GeodataPlzPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends GeodataPlz> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedPlz = false;
  

          hasChangedGeodataOrts = false;
      

    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "PLZ", nullable = GeodataPlzConstants.PLZ_NULLABLE, length=GeodataPlzConstants.PLZ_MAX_LENGTH)
        
  protected java.lang.String plz =  null;

  @javax.persistence.Transient
  protected boolean hasChangedPlz = false;

  public boolean hasChangedPlz(){
    return hasChangedPlz;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertPlz = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenPlz;
  
  /**
   * 
   *
   * getter for GEODATA_PLZ.PLZ
   */
    @Override   public  java.lang.String getPlz() {
        return plz;
      }

  /**
   * 
   *
   * setter for GEODATA_PLZ.PLZ
   *
   * @param plz
   */
  @Override   public void setPlz( java.lang.String plz) {

       resetTkCache();
                  
                          java.lang.String plzInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(plz, GeodataPlzConstants.PLZ_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.plz
      , plzInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPlz |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("plz");
      }


             if (!isSeitLadenVeraendertPlz) {
          isSeitLadenVeraendertPlz = thisAttributChanged;
         if (isSeitLadenVeraendertPlz){
           wertNachLadenPlz=this.plz;
         }
       }
      

       this.plz = plzInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */
  /**
   * Beziehung N:M (bidirektional, nicht-fuehrend) zu GeodataOrts
   */
  @javax.persistence.ManyToMany(mappedBy = "geodataPlzs", fetch=javax.persistence.FetchType.LAZY)
  protected java.util.Set<de.ivu.elect.business.geodata.entity.GeodataOrt> geodataOrts;

  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  @Override
  public java.util.Set<de.ivu.elect.business.geodata.entity.GeodataOrt> getGeodataOrts(){
    if (geodataOrts == null){
      return  java.util.Collections.<de.ivu.elect.business.geodata.entity.GeodataOrt>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.geodata.entity.GeodataOrt>emptySet());
    }
    return java.util.Collections.<de.ivu.elect.business.geodata.entity.GeodataOrt>unmodifiableSet(this.geodataOrts);
  }


  @javax.persistence.Transient
  private boolean hasChangedGeodataOrts = false;

  public boolean hasChangedGeodataOrts() {
    return hasChangedGeodataOrts;
  }


 /**
  * Hinzufuegen von de.ivu.elect.business.geodata.entity.GeodataOrt
  */
  @Override
  public void addGeodataOrt(de.ivu.elect.business.geodata.entity.GeodataOrt geodataOrt){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (geodataOrt != null){
          if (this.geodataOrts == null){
            this.geodataOrts = new java.util.HashSet<>();
          }

          boolean isChanged = this.geodataOrts.add(geodataOrt);

          if(!hasChangedGeodataOrts) {
            hasChangedGeodataOrts =  isChanged;
          }

              // andere Seite der Beziehung aktualisieren
          geodataOrt.addGeodataPlz(this);
                  }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.geodata.entity.GeodataOrt
   */
  @Override
  public void removeGeodataOrt(de.ivu.elect.business.geodata.entity.GeodataOrt geodataOrt){
    try {
      if (!updateRelationship){
        updateRelationship = true;
        if (geodataOrt != null){
          if (this.geodataOrts != null){
            boolean isChanged = this.geodataOrts.remove(geodataOrt);

            if(!hasChangedGeodataOrts) {
              hasChangedGeodataOrts =  isChanged;
            }
          }

                    // andere Seite der Beziehung aktualisieren
          if (geodataOrt != null) {
            geodataOrt.removeGeodataPlz(this);
          }
                  }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen  de.ivu.elect.business.geodata.entity.GeodataOrt
  */
   @Override
   public void removeAllGeodataOrts(){
     java.util.Set<de.ivu.elect.business.geodata.entity.GeodataOrt> toRemove = new java.util.HashSet<>(getGeodataOrts());

     for (   de.ivu.elect.business.geodata.entity.GeodataOrt entity:toRemove){
       removeGeodataOrt(entity);
     }
   }


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("GeodataPlz:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(GeodataPlz other){
                             other.plz = this.plz;
           


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(GeodataPlz.class)){
        copyEntityAttributesUsingSetter((GeodataPlz) other.castTo(GeodataPlz.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von GeodataPlz: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(GeodataPlz other){
               other.setPlz(this.plz);
       
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(GeodataPlz other){
                       if (hasChangedPlz) {
        other.setPlz(this.plz);
      }
             }





    @javax.persistence.Transient
    private transient GeodataPlzTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public GeodataPlzTK getGeodataPlzTK(){
    if (tkCache==null) {
    tkCache = new GeodataPlzTK(

getPlz()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getGeodataPlzTK();
    }

  @Override
  public GeodataPlzUK getUk(){
    return getGeodataPlzUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return GeodataPlz.class;
  }

public GeodataPlzUK getGeodataPlzUK(){

   return  new GeodataPlzUK(

getPlz()


  );
}

  @javax.persistence.Transient
  private transient GeodataPlzProperties properties;

  public GeodataPlzProperties getProperties(){
    if (properties == null) {
      properties = new GeodataPlzProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public GeodataPlzProperties getGeodataPlzProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return GeodataPlzConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(GeodataPlzConstants.MESSAGE_KEY_PLZ_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(GeodataPlzConstants.MESSAGE_KEY_PLZ_EINZAHL);

        plz =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertPlz) {
      result.put(GeodataPlzConstants.MESSAGE_KEY_PLZ_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenPlz , plz));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertPlz = false;
      wertNachLadenPlz = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "GEODATA_PLZ";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "GeodataPlz";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(plz, this, GeodataPlzConstants.MESSAGE_KEY_PLZ_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(GeodataPlzConstants.PLZ_MAX_LENGTH , 1 ,  plz, this, GeodataPlzConstants.MESSAGE_KEY_PLZ_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        private transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
